
/*

The FINDIT program creates a test database where you can see how the speed
search functions work compared to the sequential searches. You can create the
test database and determine how many elements you want in the database. The
test databse contains 2 fields, search and search2. The program will fill them
with numeric text strings. Search indexes are then created using the two fields.

*/
nLength:=4
nFcount:=5
// Name of source database.
cSource:="test"

//Name of search database..
cSearch:=trim(left(cSource,5))+"snd"

// Determine the fields to create indexes on
aCd:={"search","search2"}

// Determine delimiter to create indexes on
cDD:=" "

set softseek on
set deleted on

openss(cSource,cDD,aCd)


A=space(4)
cC=" "

do while .T.
clear

 @3,1 say "Menu"
 @4,1 say "C-Create new search database"
 @5,1 say "S-Search for value"
 @6,1 say "E-Edit data"
 @7,1 say "A-Add new data"
 @8,1 say "D-Delete record"
 @9,1 say "Q-Quit"

 @ 11,1 say  "Enter choice " get cC
 read
cc=upper(cc)

do case

  case cc="C"

   maketest()

  case cc="A"
    select (cSource)
    clear
    append blank
      @ 1,1 say "Edit field: " get search picture "@!"
      @ 2,1 say "Edit field 2: " get search2 picture "@!"
      read

     Cghline(cSource,cDD,aCd)

  case cc="S"
   do while Lastkey()!=27
   clear
    @ 1,1 say "Enter search string " get a picture "@!"
   read
   if lastkey()!=27
   ? "Press any key to start "

   wait""

    nSt:=seconds()
    snd(trim(a))
    nEs:=seconds()-nSt

    ? "Press any key to continue sequentially "
    wait""
    nStq:=seconds()
    seq(trim(a))
    nEsq:=seconds()-nStq

     ? "Time taken to search using speed search "+ltrim(str(nEs))
     ? "Time taken to search using sequential search "+ltrim(str(nEsq))
    wait ""
   endif
   enddo

    case cc="E"
    select (cSource)
     dbedit()

      clear
       @ 1,1 say "Edit field: " get search picture "@!"
       @ 2,1 say "Edit field 2: " get search2 picture "@!"
      read

       if lastkey()!=27
        Cghline(cSource,cDd,aCd)
       endif

    case cc="D"  // Delete record
    select (cSource)
     dbedit()

       if lastkey()!=27
        nDr:=recno()
        delete
        DeleteIt(cSource,recno())
       endif

    case cc="Q"
      quit
endcase

enddo

// Performs a sequential search on the database using the $ operator
  
function seq(cSt)

select (cSource)
go top
 ? cst
  do while .not. eof()
   if cst $ search .or. cst $ search2
   ? search+" "+search2
  endif
  skip
 enddo
return NIL

// Performs a search using the speed search indexes.

function snd(cSt)
local cS

// Select search database
select (cSearch)
// Change order to one. This is the index order to search on
set order to 1

 // Convert searchstring to upper case
 cS:=trim(upper(cSt))
 // Findit..
 seek cs

 /*The following lines are important, since the search database indexes into
 the record number in the source, no indexes can be active while displaying
 search matches. Therefore the index order for the source is set to 0. This does
 not deactivate any changes in any indexes for the source database */

 nOi=(cSource)->(indexord())  // Store current index order for source
 (cSource)->(dbsetorder(0))   // Set index order to 0 for source

 display (cSource)->search+" "+(cSource)->search2 WHILE sndex=cs
 // Set back to the original index order.
 (cSource)->(dbsetorder(nOi))
return NIL


// The maketest function creates a database and search database.

function maketest()

 local nF,nF2,nI:=0,cA2

clear
@ 1,1 say "Enter number of iterations? (Each iteration creates 2000 items):" get nI
read
select (cSource)
zap
for nF:=1 to nI
 for nF2:=0 to 1999
   cA:=""
  cA+=str(nF2*5,5)
  cA+=str(nF2*5+1,5)
  cA+=str(nF2*5+2,5)
  cA+=str(nF2*5+3,5)
  cA2:= str(nF2*5+4,4)
  append blank
  replace search with cA
  replace search2 with cA2
 next
next
@ 5,1 say "Generating Search Indexes - Please wait "
recreate(cSource,cDD,aCd)
return NIL


