/*
   Testing Scrollable Get Classe (in TBGet.Prg), Classy 2.x required

   Daniel-Tri Nguyen, NK-Informatique, France, CIS: 100333,3347

Compil & Link:
   please see the header of TBget.prg
*/
function TestTBget

local nCX, lBlk, cClr

set(_SET_BELL      , .F.)
set(_SET_SCOREBOARD, .F.)
set(_SET_CONFIRM   , .T.)
set(_SET_WRAP      , .T.)
set(_SET_MESSAGE, maxrow() ) ; set(_SET_MCENTER, .T. )
set(_SET_ESCAPE, .T.)

lBlk := setblink(.F.)
cClr := setcolor("w/b,n/bg,,,gr+/b")

while .T.
  @ 0, 0, maxrow(), maxcol() box replicate(chr(177),9) color "w/n"
  @ 0, 0, 0, maxcol() box space(9) color "n/g"
  @ 0, 16 say "Multi-Page & Scrollable Gets - OOP version" color "n/g"
  @ 1, 20 say "Jo W. French & Daniel-Tri Nguyen" color "w/n"
  @ 10, 20, 15, 55 box "Ŀ "
  @ 12, 22 prompt "One column, No get's captions"
  @ 13, 22 prompt "Multi Columns + Get's captions"
  menu to nCX
  if nCX == 0
    exit
  elseif nCX == 1
    Simple()
  elseif nCX == 2
    Complex()
  endif
enddo

setblink(lBlk)
setcolor(cClr)
cls

return (nil)
//TestTBget




/*
   Test MultiPage Scrollable gets, One column, no Get's captions
*/
static function Simple

local getlist := {} , mydata_, kk, scrsav, cursSav

#define NBLIG_GAMME    50 // nb de lignes maxi dans une gamme
#define LARGE_DESCRIP  50 // largeur d'une ligne de description

scrsav  := savescreen(0, 0, maxrow(), maxcol())
cursSav := setcursor(1)

dispbegin()
// data to gets and modify
mydata_ := array(NBLIG_GAMME)
for kk := 1 to len(mydata_)
  mydata_[kk] := padr("Line" + str(kk, 3, 0) ;
    + if(empty(kk % 7), + " --- " + replicate(chr(kk), 10) ,"") ,;
    LARGE_DESCRIP)
  @ kk, 2 get mydata_[kk]
next
// keep trace of relatives ccordinates, we'll need them to convert
// in screen absolute coord. later
// :colorspec : 1st = unactive gets, 2nd: get having focus
// Note: DON'T forget this line
aeval(getlist, {|o| o:cargo := { o:row, o:col } ,;
        o:colorspec := "n/w, w+/b" } )
dispend()

@ 0, 0, maxrow(), maxcol() box replicate(chr(177),9) color "w/n"
// nil = no says caption
ScrolGet():new(3, 5, 16, 60, getlist, nil, "Description", "n/bg"):Exec()


restscreen(0, 0, maxrow(), maxcol(), scrsav)
setcursor(cursSav)

return (nil)
//Simple






/*
  Complex gets, multi column, multipage, get's captions
*/
static function Complex

local getlist := {} , kk, scrsav, cursSav, nTmp
local sayCap_, mydata_

scrsav  := savescreen(0, 0, maxrow(), maxcol())
cursSav := setcursor(1)

// define get's caption in 1D array 
sayCap_ := array(27)
sayCap_[ 1] := " Last Name:                       First Name:"+;
            "                   Initial:  .   "
sayCap_[ 2] := " Date of Birth:            Social Security #:"+;
            "     -  -              Sex:      "
sayCap_[ 3] := "****************************** DOS Programs *"+;
            "*********************************"
sayCap_[ 4] := " dBase Program  1:                     "+;
            " dBase Program  2:                     "
sayCap_[ 5] := " WordProcessor  1:                     "+;
            " WordProcessor  2:                     "
sayCap_[ 6] := " SpreadSheet    1:                     "+;
            " SpreadSheet    2:                     "
sayCap_[ 7] := " Prog.Language  1:                     "+;
            " Prog.Language  2:                     "
sayCap_[ 8] := " Communications 1:                     "+;
            " Communications 2:                     "
sayCap_[ 9] := " Miscellaneous  1:                     "+;
            " Miscellaneous  2:                     "
sayCap_[10] := "************************** Windows Programs *"+;
            "*********************************"
sayCap_[11] := " dBase Program  1:                     "+;
            " dBase Program  2:                     "
sayCap_[12] := " WordProcessor  1:                     "+;
            " WordProcessor  2:                     "
sayCap_[13] := " SpreadSheet    1:                     "+;
            " SpreadSheet    2:                     "
sayCap_[14] := " Prog.Language  1:                     "+;
            " Prog.Language  2:                     "
sayCap_[15] := " Communications 1:                     "+;
            " Communications 2:                     "
sayCap_[16] := " Miscellaneous  1:                     "+;
            " Miscellaneous  2:                     "
sayCap_[17] := "***************************** OS/2 Programs *"+;
            "*********************************"
sayCap_[18] := " dBase Program  1:                     "+;
            " dBase Program  2:                     "
sayCap_[19] := " WordProcessor  1:                     "+;
            " WordProcessor  2:                     "
sayCap_[20] := " SpreadSheet    1:                     "+;
            " SpreadSheet    2:                     "
sayCap_[21] := " Prog.Language  1:                     "+;
            " Prog.Language  2:                     "
sayCap_[22] := " Communications 1:                     "+;
            " Communications 2:                     "
sayCap_[23] := " Miscellaneous  1:                     "+;
            " Miscellaneous  2:                     "
sayCap_[24] := "***************************************"+;
            "***************************************"
sayCap_[25] := " Remarks:                              "+;
            "                                       "
sayCap_[26] := "                                       "+;
            "                   CIS ID:             "
sayCap_[27] := "***************************************"+;
            "***************************************"

// define data to get / modify 
mydata_ := array(45)

// gets at the starting of TB
mydata_[ 1] := "French              "
mydata_[ 2] := "Jo             "
mydata_[ 3] := "W"
mydata_[ 4] := CTOD("")
mydata_[ 5] := SPACE(11)
mydata_[ 6] := "M"

// gets in two columns
nTmp := 6 // starting init from this element (excluded itself)
for kk := 4 to 23
  // line 10 and 17 represents plain text, there's any gets on these lines
  if !( kk == 10 .or. kk == 17 )
    mydata_[++nTmp] := mydata_[++nTmp] := ;
      padr("Line" + str(kk, 3, 0), 19)
  endif
next

// some other gets at the end of the TB
mydata_[43] := padr("Line 25  (Daniel-Tri says you Bonjour !)", 67)
mydata_[44] := padr("Line 26", 56)
mydata_[45] := "74730,1751"

// creating getlist 

dispbegin()
// ATTN: Initial get Rows are relative to the TBrowse window
@  1, 12 get mydata_[ 1]
@  1, 47 get mydata_[ 2]
@  1, 73 get mydata_[ 3] picture "@!R X."
@  2, 16 get mydata_[ 4]
@  2, 47 get mydata_[ 5] picture "999-99-9999"
@  2, 73 get mydata_[ 6] picture "!"
nTmp := 6
// on dmarre  la ligne 4 car la ligne 3 est occupe par
// la ligne de sparation "**** DOS Programs ****"
for kk := 4 to 23
  // la ligne 10 et 17 reprsente les ligne de sparation
  // groupe Windows ou groupe OS2 say seul sans Get
  if !( kk == 10 .or. kk == 17 )
    @ kk, 19 get mydata_[++nTmp]
    @ kk, 58 get mydata_[++nTmp]
  endif
next
@ 25, 10 get mydata_[43]
@ 26,  1 get mydata_[44]
@ 26, 66 get mydata_[45]

// keep trace of relatives ccordinates, we'll need them to convert
// in screen absolute coord. later
// :colorspec : 1st = unactive gets, 2nd: get having focus
// Note: DON'T forget this line
aeval(getlist, {|o| o:cargo := { o:row, o:col } ,;
        o:colorspec := "n/w,w+/r" } )
dispend()

@ 0, 0, maxrow(), maxcol() box space(9) color "w/n*"
// nil = no column heading
ScrolGet():new(5, 0, 16, 79, getlist, sayCap_, nil, "w/b"):Exec()


restscreen(0, 0, maxrow(), maxcol(), scrsav)
setcursor(cursSav)

return (nil)
//Complex






//TBgCli.Prg//

