/*
   BOSS Computer Services 
   Copyright All Rights Reserved

   Program Name: TEST9.PRG (fooling around with Tbrowse)
   Language: CA-Clipper V5.2d

   Author: Paul J. Bosselaers
   Date: 05/16/95 Time: 18:45:44

   Comment/Usage Notes: needs CHGRATTR.OBJ
      Highlight entire row of Tbrowse, using different colors depending
      on conditions in file.

      Compile:  CLIPPER test9 /M /W
      Link:     RTLINK FI test9, chgrattr  
       or       EXOSPACE FI test9, chgrattr
*/
#include "Setcurs.ch"
#include "Inkey.ch"
#include "Box.ch"
#define cAREA_CODE LEFT(PHONELST->PHONE_NO,3)

#define TbCurRow    oTbr:rowPos + oTbr:nTop + 1
#define TbRect      { oTbr:rowPos, 1, oTbr:rowPos, oTbr:colCount }

// heading separator
#define DEF_HSEP    chr(205) + chr(205) + chr(205)

LOCAL oTbr, cNormClr, cHLClr, oTbc1, oTbc2, bDiffColor
LOCAL nT, nL, nB, nR
LOCAL nKey := 0, lExitRequested
LOCAL nOldCursor := SETCURSOR(), cOrigColor := SETCOLOR()
LOCAL nNormAttr, nBarAttr

// define Tbrowse coords
nT := 7
nL := 18
nB := 17
nR := 62

// define colors        (Ok, so they're not great colors)
cNormClr  := 'BG/N,G/N,N/N,R/N,W+/N'
cHLClr    := 'GR+/N'
nNormAttr := 3      // BG/N
nBarAttr  := 94     // GR+/RB

// take care of screen, dbf
USE PHONELST New Index NAMEX
SETCOLOR(cNormClr)
CLEAR SCREEN
@ nT-2, 0 SAY PADC("Tbrowse Demo",80)
SETCOLOR(cHLClr)
@ nT-1, nL-1, nB+1, nR+1 BOX B_DOUBLE_SINGLE 
@ nT+1, nL-1 SAY CHR(198)
@ nT+1, nR+1 SAY CHR(181)

// define Tbrowse
oTbr := TbrowseDB(nT,nL,nB,nR)
oTbr:headSep := DEF_HSEP
oTbc1 := TBColumnNew("Name",  {|| PHONELST->Name })
oTbc2 := TBColumnNew("Phone No",  {|| PHONELST->Phone_no })

// different colors depending on evaluation of code block
bDiffColor := {|| GetColorPair(cAREA_CODE) }
oTbr:colorSpec := cHLClr + "," + cNormClr
oTbc1:colorBlock := {|| EVAL(bDiffColor) }
oTbc2:colorBlock := oTbc1:colorBlock

oTbr:addColumn(oTbc1)
oTbr:addColumn(oTbc2)
oTbr:autolite := .F.    // shut off highlight bar, we'll do it ourselves
SETCURSOR(SC_NONE)

lExitRequested := .F.
DO WHILE !lExitRequested

  // reset attributes of current row (get rid of highlight bar)
  ChgRowAttr(TbCurRow,nL+1,nR-1,nNormAttr)
  // this next line is needed because we are using different colors
  oTbr:colorRect(TbRect, EVAL(bDiffColor) )

  // redraw
  DO WHILE !oTbr:stabilize()
  ENDDO

  // signal bof or eof
  IF oTbr:hitTop .OR. oTbr:hitBottom
    TONE(125,2)
  ENDIF

  // draw highlight bar in appropriate color
  // Note: after stabilizing we will be at the next row position, up or
  // down, according to previous key pressed.
  nBarAttr := GetBarAttr(cAREA_CODE)
  ChgRowAttr(TbCurRow,nL+1,nR-1,nBarAttr)

  // get next key
  nKey := InKey(0)

  // take care of it (just up & down movements allowed)
  DO CASE
    CASE nKey == K_DOWN;       oTbr:down()
    CASE nKey == K_UP;         oTbr:up()
    CASE nKey == K_PGDN;       oTbr:pageDown()
    CASE nKey == K_PGUP;       oTbr:pageUp()
    CASE nKey == K_CTRL_PGUP;  oTbr:goTop()
    CASE nKey == K_CTRL_PGDN;  oTbr:goBottom()
//    CASE nKey == K_RIGHT;      oTbr:right()
//    CASE nKey == K_LEFT;       oTbr:left()
//    CASE nKey == K_HOME;       oTbr:home()
//    CASE nKey == K_END;        oTbr:end()
//    CASE nKey == K_CTRL_LEFT;  oTbr:panLeft()
//    CASE nKey == K_CTRL_RIGHT; oTbr:panRight()
//    CASE nKey == K_CTRL_HOME;  oTbr:panHome()
//    CASE nKey == K_CTRL_END;   oTbr:panEnd()
    CASE nKey == K_ESC;        lExitRequested := .T.
  ENDCASE
ENDDO

// wrap up
PHONELST->(DBCLOSEAREA())
SETCOLOR(cOrigColor)
CLEAR SCREEN
SETCURSOR(nOldCursor)

QUIT

STATIC FUNCTION GetColorPair(cAreaCode)
  // returns a color pair (in this case both the same number) based
  // on the area code passed in. This color is for the non-highlighted rows.
  LOCAL aPair

  DO CASE
    CASE cAreaCode == "603"
      aPair := { 2, 2 }

    CASE cAreaCode == "508"
      aPair := { 3, 3 }

    CASE cAreaCode == "617"
      aPair := { 5, 5 }

    CASE cAreaCode == "202"
      aPair := { 6, 6 }

    OTHERWISE
      aPair := { 1, 1 }

  ENDCASE

RETURN (aPair)

STATIC FUNCTION GetBarAttr(cAreaCode)
  // returns an attribute number for the highlight bar based
  // on the area code passed in. Number = Foreground + ( Background * 16 )
  LOCAL nAttr

  DO CASE
    CASE cAreaCode == "603"
      nAttr := 48                   // N/BG

    CASE cAreaCode == "508"
      nAttr := 47                   // W+/G

    CASE cAreaCode == "617"
      nAttr := 79                   // W+/R

    CASE cAreaCode == "202"
      nAttr := 112                  // N/W

    OTHERWISE
      nAttr := 94                   // GR+/RB

  ENDCASE

RETURN (nAttr)
